#Load the c code through dynamic loading, need to run R CMD SHLIB first to create .so file from .c
dyn.load("binsearch.so")


#binary search for each iteration k
# tmp is a vector of length p (Qv)
# lmax - maximal possible value of lambda to consider
# tau - threshold from l1 constraint
# eps - precision of achieved tau constraint
# max_iter - maximal number of iterations to search
binsearch_c<-function(tmp,lmax,tau,eps=1e-2,max_iter=5000){
    lmin=0
    lambda=(lmax+lmin)/2
    v=sign(tmp)*pmax(abs(tmp)-lambda/2,0)
    # check that it's not zero before standardizing
    if (crossprod(v)!=0){
        v=v/as.numeric(sqrt(crossprod(v)))
    }
    # current l1norm
    l1norm=sum(abs(v))
    
    if (abs(l1norm-tau)<=eps) return(lambda)

    iter=0
    
    out=.C("binsearch",as.double(lambda),as.double(tmp),as.double(lmax),as.double(l1norm),as.double(tau),as.integer(p),as.double(eps),as.integer(max_iter),as.integer(iter))
    
    
    if (out[[9]]>=max_iter) warning("Failed to find appropriate tuning parameter")

 # returns the value of lambda that corresponds to tau constraint
    return(out[[1]])
}

