# Creates two pictures of set S for the example described in the paper


# Model parameters for Scenario 1
p=2
C=diag(1,p)
x=rep(0,2)
x[1]=0.2
x[2]=0.8
l=x/sqrt(t(x)%*%x)
gamma=1
Q=gamma*(l%*%t(l))

# Evaluate the pairs (h1,f1) for the grid of parameter values
f1=c()
h1=c()
for(i in 1:length(v1)){
    for (j in 1:length(v2)){
        v=as.matrix(c(v1[i],v2[j]))
        # check the C constraint
        if (t(v)%*%C%*%v<=1){
            f1=c(f1,t(v)%*%(-Q)%*%v)
            h1=c(h1,sum(abs(v)))
        }
    }
}

# Model parameters for Scenario 2
x[1]=0.5
x[2]=0.6
l=x/sqrt(t(x)%*%x)
gamma=1
Q=gamma*l%*%t(l)

# Grid of parameter values
v1=seq(-1,1,by=0.01) 
v2=seq(-1,1,by=0.01)

# Evaluate the pairs (h2,f2) for the grid of parameter values
f2=c()
h2=c()
for(i in 1:length(v1)){
    for (j in 1:length(v2)){
        v=as.matrix(c(v1[i],v2[j]))
        # check the C constraint
        if (t(v)%*%C%*%v<=1){
            f2=c(f2,t(v)%*%(-Q)%*%v)
            h2=c(h2,sum(abs(v)))
        }
    }
}


#Generate pictures of set S
par(mfrow=c(1,2))
plot(c(0,1.5),c(-1.1,0),type='n',ylim=c(-1.2,0),xlab=expression(h==group("||",v,"||")[1]), ylab=expression(f==-v^T*Q*v),main=expression("Case 1: x=(0.2,0.8)"))
points(h1,f1,cex=0.5,col='grey')
plot(c(0,1.5),c(-1.1,0),type='n',xlab=expression(h==group("||",v,"||")[1]), ylab=expression(f==-v^T*Q*v),main=expression("Case 2: x=(0.5, 0.6)"),ylim=c(-1.2,0))




